<?php

/**
 * This code was generated by
 * \ / _    _  _|   _  _
 * | (_)\/(_)(_|\/| |(/_  v1.0.0
 * /       /
 */

namespace Twilio\Rest\Preview;

use Twilio\Domain;
use Twilio\Exceptions\TwilioException;
use Twilio\InstanceContext;
use Twilio\ListResource;
use Twilio\Rest\Preview\DeployedDevices\FleetContext;
use Twilio\Rest\Preview\DeployedDevices\FleetList;
use Twilio\Version;

/**
 * @property FleetList fleets
 * @method FleetContext fleets(string $sid)
 */
class DeployedDevices extends Version {
    protected $_fleets = null;

    /**
     * Construct the DeployedDevices version of Preview
     * 
     * @param Domain $domain Domain that contains the version
     * @return DeployedDevices DeployedDevices version of
     *                                              Preview
     */
    public function __construct(Domain $domain) {
        parent::__construct($domain);
        $this->version = 'DeployedDevices';
    }

    /**
     * Magic getter to lazy load root resources
     *
     * @param string $name Resource to return
     *
     * @return ListResource The requested resource
     * @throws TwilioException For unknown resource
     */
    public function __get($name) {
        $method = 'get' . ucfirst($name);
        if (method_exists($this, $method)) {
            return $this->$method();
        }

        throw new TwilioException('Unknown resource ' . $name);
    }

    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     *
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call($name, $arguments) {
        $property = $this->$name;
        if (method_exists($property, 'getContext')) {
            return call_user_func_array(array($property, 'getContext'), $arguments);
        }

        throw new TwilioException('Resource does not have a context');
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() {
        return '[Twilio.Preview.DeployedDevices]';
    }

    /**
     * @return FleetList
     */
    protected function getFleets() {
        if (!$this->_fleets) {
            $this->_fleets = new FleetList($this);
        }
        return $this->_fleets;
    }
}